package App::Commentry::CommentSet;

use aliased 'App::Commentry::Comment';
use JSON;
use Moo;

has base_dir => (is => 'ro', required => 1);
has path => (is => 'ro', required => 1);

has _json => (is => 'lazy');

sub _build__json { JSON->new->utf8->pretty }

has _members => (is => 'lazy');

sub _build__members {
  my ($self) = @_;
  my $file = join('/', $self->base_dir, $self->path).'.json';
  return [] unless -e $file;
  my $text = do {
    open my $in, '<', $file
      or die "Couldn't open ${file}: $!";
    local $/; <$in>;
  };
  [ map Comment->new($_), @{$self->_json->decode($text)} ];
}

sub flatten {
  my ($self) = @_;
  @{$self->_members};
}

1;
